{Gantt.inc  contains the second half of the procedures
 necessary for GANTT.PAS
 This in necessary due to the size limitation of the
 Turbo Pascal editor.}

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
Procedure Enter_Info(var TaskMax: integer;
                     var TaskCount: integer;
                     var MaxIncr: integer;
                     var Sdate,Edate:DateType;
                     var Changed:boolean);{Update info changed}

{purpose: user enters title information
 external I/O: none
 global data: Task
              F     Length of each entry
              M     Maximum # entries, including DONE

 called by: Main
 modules used:Input_Data
              Date_Ck    }

label StartOver;          {if abandon present chart}
var i,j:integer;          {loop control}
    OKDate:boolean;       {date ck flag}
    Message:string[80];
    TaskMax0,TaskCount0:integer;{original values of these variables}
    BEDate0:BEDateType;
    tmice:boolean;        {temporarily hold mice value}

begin {Enter_Info}

   TextMode(C80);
   TextColor(C1);
   TextBackground(B1);
   ClrScr;

{set initial values}
   TaskCount0:=0;
   TaskMax0:=0;
   for i:=1 to Tmax do
       if length(Task.N[i].name)>TaskMax0 then
          TaskMax0:=length(Task.N[i].name);

   while (i>1) and (TaskCount0=0) do begin
       if Task.N[i].name<>'' then taskCount0:=i;
       i:=i-1;
   end;

   BEDate0:=Task.D;

 {bottom of screen message}
   TextBackground(B2);
   TextColor(C2);
   Message:='Arrow keys';
   if Mice then Message:=Message + '/Mouse';
   Message:=Message+' to move                            ';
   Message:=Message+'<cr> on DONE when finished';
   gotoxy(1,25);
   insline;
   i:=40 - length(message) div 2; {center message}
   Message:=copy('                                  ',1,i) + Message;
   write(message);
   gotoxy(1,24);write('<Esc> to quit');

   {set parameters}
   F:=30; {titles are 30 characters long}
   M:=7; {6 entries plus DONE}

   {initialize input matrix}
   for i:=1 to 3 do begin
       temp[i].st:=Task.T[i];
       temp[i].x:=50;
       temp[i].y:=3 + 2*i;
   end;
   for i:=4 to 6 do begin
       temp[i].st:=Task.T[i];
       temp[i].x:=50;
       temp[i].y:= 6 + 2*i;
   end;
   temp[7].x:=50;
   temp[7].y:=23;
   temp[7].st:='';

{enter titles}

   {prompts and screen design}
   TextColor(C1);
   TextBackground(B1);
   gotoxy(20,temp[1].y); write('Enter 3 Headings:');
   gotoxy(20,temp[4].y);write('Enter 3 Footings:');

   TextColor(C4);
   TextBackground(B4);
   gotoxy(temp[M].x,temp[M].y); write('DONE');

   TextColor(C5);
   TextBackground(B5);

   Input_Data;
   if Abandon then goto StartOver;

   for i:=1 to 6 do Task.T[i]:=temp[i].st;

{enter task names}
   {set parameters}
   F:=30; {task names are 30 characters long}
   M:=Tmax+1; {tmax entries plus DONE}

   {initialize input matrix}
   for i:=1 to Tmax do begin
       temp[i].st:=Task.N[i].name;
       temp[i].x:=50;
       temp[i].y:=1 + i;
   end;
   temp[tmax+1].x:=50;
   temp[tmax+1].y:=23;
   temp[tmax+1].st:='';

   {prompts and screen design}
   TextColor(C1);
   TextBackground(B1);
   clrscr;
   gotoxy(20,2); write('Enter up to 20 task names:');

   TextColor(C4);
   TextBackground(B4);
   gotoxy(temp[M].x,temp[M].y); write('DONE');

   {*** perhaps need to eliminate blank rows?  User may
        like control of this.***}

   repeat
      TextColor(C5);
      TextBackground(B5);
      Input_Data;
      if Abandon then goto StartOver;

      for i:=1 to Tmax do Task.N[i].name:=temp[i].st;

   {count the tasks}
      TaskCount:=0;
      i:=Tmax;
      while (i>=1) and (TaskCount=0) do begin
         if Task.N[i].name<>'' then TaskCount:=i;
         i:=i-1;
      end;
      if TaskCount<1 then begin
         TextBackground(B1);
         TextColor(C1);
         gotoxy(10,23);writeln('You must have at least one task');
         ESC;
         if abandon then goto StartOver;
         TextBackground(blue);
         gotoxy(10,23);write('                                ');
      end;
   until TaskCount>0;

   for i:=1 to Tmax do Task.N[i].name:=temp[i].st;

{find the length of the longest task}
   TaskMax:=0;
   for i:=1 to Tmax do
     if TaskMax<length(Task.N[i].name) then
        TaskMax:=length(Task.N[i].name);

{calculate the maximum number of months allowed}
   MaxIncr:=(W-2-TaskMax)div 4;
{enter dates}

   {set parameters}
   F:=2; {dates are 2 characters long}
   M:=7; {two dates @ 3 entries plus DONE}

   {initialize input matrix}
     temp[1].st:=Task.D[1].month;temp[1].x:=48;temp[1].y:=10;
     temp[2].st:=Task.D[1].day;  temp[2].x:=51;temp[2].y:=10;
     temp[3].st:=Task.D[1].year; temp[3].x:=54;temp[3].y:=10;

     temp[4].st:=Task.D[2].month;temp[4].x:=48;temp[4].y:=12;
     temp[5].st:=Task.D[2].day;  temp[5].x:=51;temp[5].y:=12;
     temp[6].st:=Task.D[2].year; temp[6].x:=54;temp[6].y:=12;

     temp[7].st:='';
     temp[7].x:=50;temp[7].y:=14;

   {prompts and screen design}
   TextColor(C1);
   TextBackground(B1);
   window(1,1,80,25); {remove message from bottom of screen, since
                                     mouse is not used for dates}
   clrscr;
   TextColor(C2); TextBackground(B2);
   gotoxy(1,25);write('<Esc> to quit');
   TextColor(C1);TextBackground(B1);

   gotoxy(15,temp[1].y); write('Project Start Date (mm/dd/yy):');
   gotoxy(15,temp[4].y); write('Project Finish Date (mm/dd/yy):');

   gotoxy(14,temp[1].y-3);
   write(' Start Month to End Month is limited to ');
   write(MaxIncr:2,' months');

   TextColor(C4);
   TextBackground(B4);
   gotoxy(temp[M].x,temp[M].y); write('DONE');
   TextColor(C1);
   TextBackground(B1);
   gotoxy(temp[2].x-1,temp[2].y); write('/');
   gotoxy(temp[3].x-1,temp[3].y); write('/');
   gotoxy(temp[5].x-1,temp[5].y); write('/');
   gotoxy(temp[6].x-1,temp[6].y); write('/');

   OKdate:=false;
   tmice:=mice;
   mice:=false; {not use mouse with dates}

   repeat
     window(1,1,80,24);TextColor(C5);TextBackground(B5);
     Input_Data;
     if Abandon then goto StartOver;
     Date_CK(OKdate,MaxIncr,Sdate,Edate);
   until OKdate;

   mice:=tmice; {use mouse again}

     Task.D[1].month:=temp[1].st;
     Task.D[1].day  :=temp[2].st;
     Task.D[1].year :=temp[3].st;
     Task.D[2].month:=temp[4].st;
     Task.D[2].day  :=temp[5].st;
     Task.D[2].year :=temp[6].st;

{set CHANGED flag}
   Changed:=false;
   if TaskMax<>TaskMax0 then changed:=true;
   if TaskCount<>TaskCount0 then changed:=true;
   for i:=1 to 2 do begin
       if Task.D[i].month<>BEDate0[i].month then changed:=true;
       if Task.D[i].day<>BEDate0[i].day then Changed:=true;
       if Task.D[i].year<>BEDate0[i].year then Changed:=true;
   end;

StartOver:
   window(1,1,80,25);
   clrscr;
end; {Enter_Info}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Make_Chart(Sdate,Edate:DateType; {start and stop dates}
         TaskCount:integer; {number of tasks}
         TaskMax: integer;  {length of longest task-input only}
     var Chart:ChartType;
         MaxIncr:integer;   {Max # of time increments}
     var ChartWidth:integer;{including the chart borders}
         Changed:boolean);   {if chart parameters changed}
{purpose: calculate the chart display
 external I/O: none
 global data: Task
 Called by: Time_Spans
 Modules used: Date
               UnDate  }

var i,j,k:integer;
    dx,   {# of columns/date increment;}
    modx:integer; {extra spaces from TaskMax to chart}
    temp: string[2];
    Mo:array[1..MaxDates] of string[3];
    Wk:array[1..MaxDates] of string[2];
    N1,N2:real; {used in calculating week dates}
    x2:integer; {start character of timespan on page 1}
    DateCount:integer; {number of date increments}
    Line,St:Str150;

begin {Make_Chart}

{Count Months}
    DateCount:=(Edate.yr-SDate.yr)*12 + Edate.mo-Sdate.mo+1;

{if large elapsed time, then increment by months}
    if (MaxIncr < ((DateCount-1)*4.4)) then begin

{show whole of last month}
      if Edate.mo<>12 then Edate.mo:=Edate.mo+1
      else begin
           Edate.mo:=1;
           Edate.yr:=Edate.yr+1;
      end;


      if DateCount>1 then dx:=(W - TaskMax - 2) div DateCount
          else dx:=0;
       Modx:=(W - TaskMax - 2) mod DateCount;
       x2:= dx*DateCount - 79 + TaskMax + 2 + Modx;

{year dates across top of chart}
    Chart[1]:='';
    str(Sdate.yr:2,temp);
    Chart[2]:=Copy(blank,1,TaskMax+Modx-1)+'19'+temp;
    if Sdate.yr<>Edate.yr then begin
       str(Edate.yr:2,temp);
       Chart[2]:=Chart[2]+Copy(blank,1,W-TaskMax-Modx-7)+'19'+temp;
    end; {if change in years}

{month dates across top of chart}
    Chart[3]:=Copy(blank,1,TaskMax+Modx-1);
    j:=Sdate.mo;
    for i:=1 to DateCount do begin
        Chart[3]:=Chart[3]+Months[j]+Copy(blank,1,dx-3);
        if j=12 then j:=1 else j:=j+1;
    end; {month dates across top}

    insert(Months[Edate.mo],Chart[3],W-2);
  end {month increments}

{increment by weeks}
  else begin {week increments}

{calculate parameters}
       UnDate(Sdate,N1); {convert to integer}
       UnDate(Edate,N2);
       DateCount:=round(N2-N1) div 7;
       dx:=(W - TaskMax - 2) div (DateCount);{width of a increment}
       Modx:=(W - TaskMax - 2) mod (DateCount);{remainder of dx}
       x2:= dx*(DateCount) - 79 + TaskMax + 2 + Modx;
       N1:=int(N2-(7*DateCount)); {round start date to nearest week}
       Date(Sdate,N1);

{year dates across top of chart--printed output only}
    str(Sdate.yr:2,temp);
    Chart[1]:=Copy(blank,1,TaskMax+Modx-1)+'19'+temp;
    if Sdate.yr<>Edate.yr then begin
       str(Edate.yr:2,temp);
       Chart[1]:=Chart[1]+Copy(blank,1,W-TaskMax-Modx-7)+'19'+temp;
    end; {if change in years}

{Month line / day line}
    for i:=1 to (TaskMax+Modx) do begin {leading spaces}
        Chart[2]:=Copy(blank,1,TaskMax+Modx-1);
        Chart[3]:=Chart[2];
    end;
    Mo[1]:=Months[Sdate.mo];
    str(Sdate.da:2,Wk[1]);
    for i:=2 to datecount+1 do begin
        N1:=N1+7;
        Date(Sdate,N1);{note: using start date as local variable}
        Str(Sdate.da:2,Wk[i]);
        if Sdate.da<8 then Mo[i]:=Months[Sdate.mo]
                      else Mo[i]:='   ';
    end;

    for i:=1 to DateCount do begin
        Chart[2]:=Chart[2]+Mo[i]+Copy(blank,1,dx-3);
        Chart[3]:=Chart[3]+Wk[i]+Copy(blank,1,dx-2);
    end; {months / weeks}
    insert(Mo[Datecount+1],Chart[2],W-2);
    insert(Wk[DateCount+1],chart[3],W-2);
 end; {week increments}

 ChartWidth:=dx*DateCount+1; {width of chart, including borders}

{Construct Chart}
{tasknames}
  st:=copy(blank,1,dx-1)+'|';
  line:=#179;
  for i:=1 to DateCount-1 do line:=line+st;
  delete(st,dx,1);
  Insert(#179,st,dx);
  line:=line+st;

  for i:=5 to (TaskCount+4) do begin
      j:=TaskMax+Modx-length(Task.N[i-4].name);
      if not Changed then
         Chart[i]:=Task.N[i-4].name+Copy(blank,1,j) + Task.N[i-4].timespan
      else
         Chart[i]:=Task.N[i-4].name + Copy(blank,1,j) + line;
  end;

  {Blank line on chart--kept in Chart[L]}
  Chart[L]:=copy(blank,1,TaskMax+modx)+line;

  {Top and Bottom borders of chart}
  j:=taskCount+5; {subscript of bottom border of Chart}
  Chart[4]:=copy(blank,1,TaskMax+modx)+#195;
  Chart[j]:=copy(blank,1,TaskMax+modx)+#192;
  st:='';
  for i:=1 to dx-1 do st:=st+#196;
  line:=st+#196;
  st:=st+#193;

  for i:=1 to DateCount-1 do begin
      Chart[4]:=Chart[4]+st;
      Chart[j]:=Chart[j]+line;
  end;
  delete(st,dx,1);
  insert(#180,st,dx);
  delete(line,dx,1);
  insert(#217,line,dx);
  Chart[4]:=Chart[4]+st;
  Chart[j]:=Chart[j]+line;

end; {Make_Chart}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Display(ChartWidth,
                  TaskCount:integer;
                  Chart:ChartType;
              var Pg1,Pg2: MatrixType);

{purpose: initialize the chart display on page1 and page2, and
          initialize the input matricies for these pages.
 date: 4/15/87
 external I/): none
 global data: none
 called by: Time_Spans
 modules used: Page
               GoSxy
               Print }

var s, {# of blank rows between each taskname displayed on screen}
    i,j,k,
    x2, {1st column of pg2 in terms of Chart}
    x3:integer; {width of taskname area}
    message,temp:string[80];

begin {Display}

{calculate spacing}
    if TaskCount>0 then S:=(20 div TaskCount)-1 else s:=0;

{calculate portions to fit on each page: x1,x2}
    x3:=W-ChartWidth-1; {width of taskname area}
    x2:=W-77+x3;

{paint background}
    TextBackground(B3);
    TextColor(C3);
    page(1);ClrScr;
    if not narrow then page(2);ClrScr;

{Bottom message line}
    TextColor(B2);
    TextBackground(C2);
    window(1,25,80,25);
    if not narrow then page(2);clrscr;
    page(1);clrscr;

    if mice then temp:='/left mouse button' else temp:='';
    message:='letter keys'+ temp + ' for time span';
    if mice then temp:='right button/'else temp:='';
    message:=message+'        '+temp+    '<space> to erase';

    i:=(80-length(message))div 2;
    if i<1 then i:=1;

    if not narrow then page(2);gotoSxy(2,i,25);print(2,message);
    page(1);gotoSxy(1,i,25);print(1,message);

    {<Esc> message}
    window(1,24,13,24);
    clrscr;
    message:='<Esc> to Quit';
    gotoSxy(1,1,24);print(1,message);
    if not narrow then begin
       page(2);clrscr;
       gotoSxy(2,1,24);print(2,message);
    end; {if not narrow}

    page(1);

{dates and top border}
    for i:=1 to 3 do begin {i is screen display row}
        message:=Copy(Chart[i+1],1,79);
        gotoSxy(1,1,i);print(1,message);

      if not narrow then begin
        message:=Copy(Chart[i+1],x2,78-x3);
        gotoSxy(2,x3+1,i);
        print(2,message);
      end; {if not narrow}
    end; {dates and top border}

{display task lines}
    k:=i+1;   {k=screen row number}
    i:=5;
    while i<= TaskCount+3 do begin {i=Chart row number}

        if narrow then Message:=Chart[i] else
           message:=Copy(Chart[i],1,77);
        gotoSxy(1,1,k);Print(1,message);
      if not narrow then begin
        Message:=Copy(Chart[i],1,x3)+Copy(Chart[i],x2,80-x3);
        gotoSxy(2,1,k);Print(2,message);
      end; {if not narrow}
        k:=k+1;
        i:=i+1;

{blank rows}
        for j:=1 to s do begin
            message:=Copy(Chart[L],1,80);
            gotoSxy(1,1,k);print(1,message);
          if not narrow then begin
            message:=Copy(Chart[L],x2,80-x3);
            gotoSxy(2,x3+1,k);print(2,message);
          end; {if not narrow}
            k:=k+1;
       end;
    end;

{last taskname and bottom line on chart}
    for i:=i to i+1 do begin
        Message:=Copy(Chart[i],1,80);
        gotoSxy(1,1,k);Print(1,message);
      if not narrow then begin
        Message:=Copy(Chart[i],1,x3)+Copy(Chart[i],x2,80-x3);
        gotoSxy(2,1,k);Print(2,message);
      end; {if not narrow}
        k:=k+1;
    end;

{DONE box}
    TextColor(C4);
    TextBackground(B4);
    window(1,1,4,1);
    message:='DONE';
    page(1);ClrScr;
  if not narrow then begin
    page(2);ClrScr;end;
    gotoSxy(1,1,1);print(1,message);
  if not narrow then begin
    gotoSxy(2,1,1);print(2,message);
  end; {if not narrow}

page(1);

{set input matricies}
    M:=TaskCount+1; {number of entries in input matrix-incl DONE}
    F:=77-x3;       {max length of an input line}
    for i:=1 to TaskCount do begin
        pg1[i].st:=Copy(Chart[i+4],x3+2,F-1);
        pg1[i].x:=x3+2;
        pg1[i].y:=i + 3 + S*(i-1);
    end;
    if Narrow then F:=F-1;

    {Done}
    pg1[M].st:='';
    pg1[M].x:=1;
    pg1[M].y:=1;

    {Blank row}
    pg1[M+1].st:= Copy(Chart[L],x3+2,F);
    pg1[M+1].x:=1;
    pg1[M+1].y:=1;

  if not narrow then begin
    for i:=1 to TaskCount do begin
        pg2[i].st:=Copy(Chart[i+4],x2-1,F);
        pg2[i].x:=x3;
        pg2[i].y:=i + 3 + S*(i-1);
    end;

    {Done}
    pg2[M].st:='';
    pg2[M].x:=1;
    pg2[M].y:=1;

    {Blank row}
    pg2[M+1].st:= Copy(Chart[L],x2-1,F);
    pg2[M+1].x:=1;
    pg2[M+1].y:=1;
  end; {if not narrow}

    TextBackground(B3);
    TextColor(C3);
end; {Display}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
Procedure Input_Data2(var Pg:MatrixType;
                      var Done:boolean;
                      var R:integer;   {current Pg row number}
                          ChartWidth:integer);

{purpose: user inputs task time spans, moving with cursor control
          keys or mouse.  Time spans are specified either by the
          alphanumeric keys or by holding down the left mouse button.
 External I/O: none
 Global data: M1..M4
              Mice
              F,M
              Abandon

 Called by: Time_Spans
 Modules used: Mouse
               Reset_Mouse
               Move_Mouse
               Move_Cursor2
               Move_Up2
               Move_Down2
               ESC       }

var p:byte;     {current page #}
    i:integer;  {loop control}
    j:integer;  {character within the line}
    message:string[80];
    ChangePage:boolean;
    dx:integer; {overlap size}
    x,y:integer; {coordinates of button press}
    x1:integer;  {x-value of button release}
    bar:string[80]; {timespan bar}
    dx1:integer; {length of bar on mouse entry}

begin {Input_Data2}
{initialize}

  if mice then M1:=1; Mouse(M1,M2,M3,M4); {show mouse--hdwe mouse}
  ChangePage:=false;
  p:=WhichPage;
  dx:= 2 * F - ChartWidth;
  bar:='';
  for i:=1 to 10 do bar:=bar+#176+#176+#176+#176+#176+#176+#176+#176;

  for i:=1 to M-1 do begin {write current contents of input matrix}
    gotoSxy(p,Pg[i].x,Pg[i].y);
    print(p,Pg[i].st);
  end;

  if done then begin  {first time through}
     done:=false;
     gotoSxy(p,Pg[1].x,Pg[1].y);
     j:=1;
     R:=1;
  end {if first time through}
  else if p=1 then begin
          gotoSxy(p,78-dx,Pg[R].y);
          j:=F-dx-1;
        end {if page1}
        else begin  {if page2}
          gotoSxy(p,Pg[R].x + dx,Pg[R].y);
          j:=dx+1;
        end; {if page2}

if mice then Move_Mouse;
  repeat
    if keypressed then begin
      read(kbd,ch);
      case ch of
        #27: if not keypressed then begin {<esc> pressed}
                ESC;
                gotoSxy(p,Pg[R].x+j-1,Pg[R].y);
             end {if <esc>}
           else begin
             read(kbd,ch);
             case ch of
               #72: begin
                    Move_Up2(Pg,R);
                    if (R=M) or (R=M-1) then j:=1;
                  end; {#72}
               #80: begin
                    Move_Down2(Pg,R);
                    if (R=M) or (R=1) then j:=1;
                  end; {#80}
               #75: {<-- }
                    if (j>1) and (R<>M) then begin
                       j:= j-1;
                       gotoSxy(p,
                               whereSx(p)-1,
                               whereSy(p));
                       if mice then Move_Mouse;
                    end {if #75}
                    else if (p=2) and (R<>M) then
                        ChangePage:=true;
               #77: {-->}
                    if (j<F) and (R<>M) then begin
                       j:=j+1;
                       gotoSxy(p,whereSx(p)+1,Pg[R].y);
                       if mice then Move_Mouse;
                     end
                     else if (p=1) and (R<>M)
                          then ChangePage:=true;
             end; {case arrow key pressed}
            end; {#27}
        #13: {<cr>} if R=M then done:=true
           else begin
                Move_Down2(Pg,R);
                if (R=M) or (R=1) then j:=1;
              end; {<cr>}
        #8: {back space or ^H }
             if (j>1) then begin
                j:= j-1;
                gotoSxy(p,
                        whereSx(p)-1,
                        whereSy(p));
                if mice then Move_Mouse;
             end {if #75}
             else if (p=2) then
                      ChangePage:=true;

     #32..#126: if R<M then begin {add ch to string if not DONE}
           delete(Pg[R].st,j,1);
           if ch=#32 then insert(Copy(Pg[M+1].st,j,1),Pg[R].st,j)
           else insert(#176,Pg[R].st,j);

           if (j=F-1) and (p=1) and (not narrow) then
              ChangePage:=true;
           if not ChangePage then begin
              M1:=2;Mouse(M1,M2,M3,M4); {Hide mouse}
              gotoSxy(p,Pg[R].x,whereSy(p));
              message:=Copy(Pg[R].st,1,j);
              print(p,message);
              M1:=1;Mouse(M1,M2,M3,M4); {Show mouse}
              if j<F then j:=j+1
              else gotoSxy(p,Pg[R].x+F-1,Pg[R].y);
              if mice then begin
                 Move_Mouse;
                 M1:=1;Mouse(M1,M2,M3,M4); {Show mouse}
              end; {if mice}
            end; {not ChangePage}
          end; {add ch to string}
        end; {case}


    end;{if keypressed}
if narrow then changepage:=false;

    if mice and (not ChangePage) then begin
       M1:=11;Mouse(M1,M2,M3,M4); {ck for mouse movement}
       if (M3<0) and (j<=1) and (p=2) then ChangePage:=true;
       if (M3>0) and (j>=F) and (p=1) then ChangePage:=true;
       if (M3<>0) or (M4<>0) then {mouse has been moved}
            Move_Cursor2(Pg,R);   {move text cursor to mouse cursor}
       j:=(whereSx(p) - Pg[R].x) + 1;
       if (j>=L) and (p=1) then ChangePage:=true;

       M1:=5;  {get button press info}
       M2:=0;  {left button}
       Mouse(M1,M2,M3,M4);
       if M2 > 0 then if R=M then done:=true;

       if (M2 > 0) and (not done) then begin
          {record coordinates of press}
          x:= whereSx(p);
          y:= whereSy(p);
          repeat
              Move_Cursor2(Pg,R);
              j:=(whereSx(p) - Pg[R].x) + 1;
              if (j>=L) and (p=1) then ChangePage:=true;
              if narrow then changepage:=false;

              M1:=6; {get button release info}
              M2:=0; {left button}
              Mouse(M1,M2,M3,M4);
          until (M1=0) or (ChangePage); {all buttons up}
          x1:=whereSx(p);
          dx1:= x1-x;
          if dx1<0 then begin
             dx1:= -1 * dx1;
             x:=x1;
          end;
          dx1:=dx1+1;
          if (dx1>0) and (R<>M) then begin
             delete(Pg[R].st,x-Pg[R].x+1,dx1);
             insert(Copy(bar,1,dx1),Pg[R].st,x-Pg[R].x+1);
          end;
          if narrow then changepage:=false;
          if not ChangePage then begin
             M1:=2;Mouse(M1,M2,M3,M4); {Hide mouse}
             gotoSxy(p,Pg[R].x,whereSy(p));
             print(p,Pg[R].st);
             j:=(x1-Pg[R].x+1);
             gotoSxy(p,Pg[R].x+j,Pg[R].y);
             M1:=1;Mouse(M1,M2,M3,M4); {show mouse}
           end;
       end; {enter timespan with mouse}

{erase timespan w/mouse}
       M1:=5;  {get button press info}
       M2:=1;  {right button}
       Mouse(M1,M2,M3,M4);

       if (M2 > 0) and (not done) then begin
          {record coordinates of press}
          x:= whereSx(p);
          y:= whereSy(p);
          repeat
              Move_Cursor2(Pg,R);
              j:=(whereSx(p) - Pg[R].x) + 1;
              if (j>=L) and (p=1) then ChangePage:=true;
              if narrow then changepage:=false;

              M1:=6; {get button release info}
              M2:=1; {right button}
              Mouse(M1,M2,M3,M4);
          until (M1=0) or (ChangePage); {all buttons up}

          x1:=whereSx(p);
          dx1:= x1-x;
          if dx1<0 then begin
             dx1:= -1 * dx1;
             x:=x1;
          end;
          dx1:=dx1+1;
          if (dx1>0) and (R<>M) then begin
             delete(Pg[R].st,x-Pg[R].x+1,dx1);
             insert(Copy(Pg[M+1].st,x-Pg[R].x+1,dx1),Pg[R].st,x-Pg[R].x+1);
          end;
          if not ChangePage then begin
             M1:=2;Mouse(M1,M2,M3,M4); {Hide mouse}
             gotoSxy(p,Pg[R].x,whereSy(p));
             print(p,Pg[R].st);
             j:=(x1-Pg[R].x+1);
             gotoSxy(p,Pg[R].x+j,Pg[R].y);
             M1:=1;Mouse(M1,M2,M3,M4); {show mouse}
           end; {if not changepage then record the info}
       end; {erase timespan with mouse}

    end; {if mice}
if narrow then changepage:=false;

  until (done) or (abandon) or (ChangePage);
  if mice then begin {hide mouse}
     M1:=2;Mouse(M1,M2,M3,M4);
  end;
end; {Input_Data2}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Overlap(var Pg1,Pg2:MatrixType;
                      ChartWidth:integer);

{purpose: copies the common timespan data between charts when
          between page1 and page2 in entering timespans
 date: 4/17/87
 external I/0: none
 global data: F
 called by: Time_Spans
 modules used: none }

var dx,  {size of overlap}
    i:integer;

begin {Overlap}
    dx:=2 * F - ChartWidth;
    if WhichPage = 1 then begin {if on page1}
       for i:=1 to M-1 do begin
           Delete(Pg2[i].st,1,dx);
           Insert(Copy(Pg1[i].st,F-dx-1,dx),Pg2[i].st,1);
       end; {for i}
       page(2);
    end  {if on page1}
    else begin {if on page2}
         for i:=1 to M-1 do begin
             Delete(Pg1[i].st,F-dx-1,dx+1);
             Insert(Copy(Pg2[i].st,1,dx+1),Pg1[i].st,F-dx-1);
         end; {for i}
         Page(1);
    end; {if on page2}
end; {Overlap}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Chart_Results(Pg1,Pg2:MatrixType;
                      var Chart:ChartType;
                          TaskCount,
                          ChartWidth:integer);

{purpose: transfer the results of entering timespans to CHART and
          Task.N.TimeSpan
 external I/O: none
 global data: F
              Task
 called by: Time_Spans
 modules used: none  }

var i,j,x3,dx:integer;
    temp:Str150;

begin {Chart_Results}

{update Chart for printing}
    dx:=2*F-ChartWidth; {overlap}
    x3:=pos(#179,Chart[L]);

if narrow then
    for i:=1 to TaskCount do begin
        if Pg1[i].st<>''then begin
           temp:=Copy(Pg1[i].st,1,F);
           delete(Chart[i+4],x3+1,F);
           insert(Pg1[i].st,Chart[i+4],x3+1);
        end; {if}
    end {for}
else
    for i:=1 to TaskCount do begin
        if (Pg1[i].st<>'') and (Pg2[i].st<>'') then begin
           temp:=Copy(Pg1[i].st,1,F-1) + Copy(Pg2[i].st,dx+2,F-dx-1);
           delete(Chart[i+4],x3+1,ChartWidth-2);
           insert(temp,Chart[i+4],x3+1);
        end; {if}
    end; {for}

{update Task}
if narrow then Chartwidth:=F+1;
    for i:=1 to TaskCount do
        Task.N[i].Timespan:=Copy(Chart[i+4],x3,ChartWidth+1);
    for i:=TaskCount+1 to Tmax do
        Task.N[i].Timespan:='';

{replace shaded bar with solid bar}
    for i:=1 to TaskCount do
        repeat
        j:=pos(#176,Chart[i+4]);
        if j>0 then begin
           delete(Chart[i+4],j,1);
           insert(#219,Chart[i+4],j);
        end;
        until j=0; {replace}

end; {Chart_Results}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Time_Spans(var Chart:ChartType;
                        SDate,EDate:DateType;
                        TaskCount:integer;
                        TaskMax,
                        MaxIncr:integer;
                        Changed:boolean);

{purpose: user enters time spans
 external I/O: none
 global data: none
 called by: Main;
 modules used: MakeChart
               Display
               Transfer_Overlap
               Input_Data2
               Results  }

var
    Pg1,Pg2:MatrixType; {2 input matricies}
    Done:boolean;
    ChartWidth,
    R:integer; {Pg subscript of current cursor location}

begin {Time_Spans}
    Make_Chart(Sdate,Edate,TaskCount,TaskMax,Chart,
               MaxIncr,ChartWidth,Changed);
    Display(ChartWidth,TaskCount,Chart,Pg1,Pg2);
    Done:=true; {this is set to false in Input_Data2; flag to tell
                 if is first time through Input_Data2}
    Repeat
       Input_Data2(Pg1,Done,R,ChartWidth);
       if not narrow then Overlap(Pg1,Pg2,ChartWidth);
       if (not Done) and (not abandon) then begin
          Input_Data2(Pg2,Done,R,ChartWidth);
          Overlap(Pg1,Pg2,ChartWidth);
       end; {if}
     until done or abandon;
     page(0);
{transfer results to Chart}
    Chart_Results(Pg1,Pg2,Chart,TaskCount,ChartWidth);
end; {Time_Spans}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Input_Filename(var filename:Str12;
                             error:boolean);
{purpose: user enters a filename to save chart under
 date: 4/19/87
 external I/O: check for duplicate filename
 global data: none
 called by: Save
 Modules used: Get_File
               WhichPage  }

const x=45;            {location of input field}
      y=5;
      st = '        '; {to clear input field}

var i,j:integer;
    temp:string[8];
    p: byte;
    message:string[30];
    fil:text;

begin {Input_Filename}
    p:=Whichpage;

{display prompt}
   if not error then begin
      window(1,1,80,25);
      TextMode(C80);
      TextColor(C1);
      TextBackground(B1);
      ClrScr;
   end; {if not error}

   TextColor(C1);
   TextBackground(B1);

   gotoxy(20,5); write('Enter filename to save:');
   TextColor(C2);TextBackground(B2);
   gotoxy(2,25);
   insline;
   write('<Esc> to abandon chart');
   gotoxy(38,25); write('<space> for disk directory or path change');

   j:=1;
   gotoxy(x,y); write(st);
   gotoxy(x,y);
   write(filename);
   gotoxy(x,y);
   temp:=filename;
   filename:='';

{enter filename}
   repeat
     if keypressed then begin
       read(kbd,ch);
       case ch of
          #27: if not keypressed then begin {<Esc> pressed}
                ESC;
                if abandon then exit;
                gotoxy(x,y);
             end {end <Esc> pressed}

             else {arrow key} begin
                read(kbd,ch);
                if ch=#75 then  {<- }
                   if j>1 then begin
                      j:=j-1;
                      gotoxy(x+j-1,y);
                   end;
                if ch=#77 then  {-> }
                   if (j<8) and (j<length(temp)) then begin
                      j:=j+1;
                      gotoxy(x+j-1,y);
                   end;
              end; {else arrow key}

          #13: {<cr>}
               if (temp<>'') then begin
                  {strip any spaces from temp}
                  repeat
                       delete(temp,pos(' ',temp),1);
                  until pos(' ',temp)=0;
                  filename:=temp;
                  {$I-} Assign(fil,filename+'.PRN');
                  if IOResult=0 then;
                  Reset(fil);{$I+}
                  if IOresult=0 then begin {file already exists}
                    gotoSxy(p,20,10);
                    message:='Overwrite this file? (Y/N)';
                    print(p,message);
                    repeat
                      read(kbd,ch);
                      ch:=upcase(ch);
                    until (ch='Y') or (ch='N');
                    if ch='N' then begin
                      filename:='';
                      temp:='';
                      gotoSxy(p,20,10);
                      message:= '                             ';
                      print(p,message);
                      j:=1;
                      gotoxy(x,y);
                      write(st);
                      gotoxy(x,y);
                    end; {if No}
                   end; {filename exists}
               end; {if temp<>''}

          #8:  {backspace or ^H}
               begin
                  delete(temp,j,1);
                  if j>1 then j:=j-1;
                  gotoxy(x,y);
                  write(st);
                  gotoxy(x,y);
                  write(temp);
                  gotoxy(x+j-1,y);
               end;

          #32: {space} begin
               filename:=GetFile;
           {restore screen}
               TextColor(C1);
               TextBackground(B1);
               ClrScr;
               gotoxy(20,5); write('Enter filename to save:');
               TextColor(C2);TextBackground(B2);
               gotoxy(2,25);
               insline;
               write('<Esc> to abandon chart');
               gotoxy(38,25); write('<space> for disk directory or path change');

               j:=1;
               gotoxy(x,y); write(st);
               gotoxy(x,y);
               write(filename);
               gotoxy(x,y);

           {filename<>''}
               if filename<>'' then begin
                  gotoxy(x,y);
                  write(filename);
                  gotoSxy(p,20,10);
                  message:='Overwrite this file? (Y/N)';
                  print(p,message);
                  repeat
                      read(kbd,ch);
                      ch:=upcase(ch);
                  until (ch='Y') or (ch='N');
                  if ch='N' then begin
                     filename:='';
                     gotoSxy(p,20,10);
                     message:= '                             ';
                     print(p,message);
                     gotoxy(x,y);
                     write(st);
                     gotoxy(x,y);
                     temp:='';
                     j:=1;
                  end; {if No}
               end {filename<>''}

           {filename=''}
               else begin {if filename=''}
                    ESC;
                    if abandon then exit;
                    gotoxy(x,y);
                    write(temp);
                    gotoxy(x,y);
               end; {filename=''}

             end; {space}

          #48..#57: {numbers}
               if j<>1 then begin
                  delete(temp,j,1);
                  insert(ch,temp,j);
                  if j<8 then j:=j+1;
                  gotoxy(x,y);write(temp);
                  gotoxy(x+j-1,y);
               end;

          #65..#90,#97..#122: {letters} begin
                  delete(temp,j,1);
                  insert(upcase(ch),temp,j);
                  if j<8 then j:=j+1;
                  gotoxy(x,y);write(temp);
                  gotoxy(x+j-1,y);
               end;

     end; {case}
   end; {if keypressed}

{select default filename with mouse}
   if mice then begin
      M1:=5; {get button status}
      M2:=0; {left button}
      Mouse(M1,M2,M3,M4);
      if M2>0 then filename:=temp;
   end; {if mice}

   until filename<>'';

end; {Input_Filename}

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Save(Chart:ChartType;
               TaskCount:integer;
               var Filename:str12);

{purpose: save chart as PRN file and DTA file
 external I/O: filename.DTA
               filename.PRN
 global data: Task  (input)
 called by: Main
 modules used: Input_Filename }

label DatFile,PrtFile;

var PrnFile:text;
    DtaFile:file of TaskType;
    TitleLine:array[1..6] of Str150;
    i,j,k:integer;
    Empty:Str150;
    Spaces:integer;
    Error:boolean; {whether an I/O error has been trapped}
    st:char;

begin {Save}

   error:=false;
{save .DTA file}
   Input_filename(filename,error);
   if abandon then exit;

{$I-} {allow i/o error trapping}
   assign(DtaFile,filename+'.DTA');
   Error_Ck(error);
   if error then goto DatFile;

   rewrite(DtaFile);
   Error_Ck(error);
   if error then goto DatFile;

   Write(DtaFile,Task);
   Error_Ck(error);

DatFile:
   close(DtaFile);
   Error_Ck(error);
   if error then begin
      Erase(DtaFile);
      error:= (IOResult<>0);
      Exit;
   end;

{save .PRN files}

{construct title lines}

{Headings}
if (W<110) and (not narrow) then {if using SideWriter}
   for i:=1 to 3 do begin
 {center title line: will NOT be Enlarged, so length div 2}
       k:=(W div 2) - length(Task.T[i]) div 2;
       TitleLine[i]:=Copy(blank,1,k) + Task.T[i];
   end {for Headings}
else
   for i:=1 to 3 do begin
 {center title line: will be Enlarged, so NOT length div 2}
       k:=(W div 2) - length(Task.T[i]);
       TitleLine[i]:=Copy(blank,1,k) + #14 + Task.T[i];
   end; {for Headings}

{Footings}
   for i:=4 to 6 do begin
{right justify footings: will be normal size font}
       k:=W-length(Task.T[i])-1;
       TitleLine[i]:=Copy(blank,1,k)+Task.T[i];
   end; {for Footings}

{calculate spaces :6 title lines;
                      2 top,bottom rows
                      3 dates}
   Spaces:=(L-13) div TaskCount - 1;{#spaces between rows}

if (W>80) and (W<110) then begin {using SWC.Com}
{Replace extended ASCII characters}

   For i:=3 to L do begin

{left top corner}
   st:=#32;
   j:=pos(#195,Chart[i]);
   if j<>0 then begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
   end;
{right top corner}
   j:=pos(#180,Chart[i]);
   if j<>0 then begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
   end;
{left bottom corner}
   st:=#124;
   j:=pos(#192,Chart[i]);
   if j<>0 then begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
   end;
{right bottom corner}
   j:=pos(#217,Chart[i]);
   if j<>0 then begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
   end;
{Horizontal lines}
   st:=#95;
   j:=pos(#196,Chart[i]);
   while j<>0 do begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
      j:=pos(#196,Chart[i]);
   end;
{date ticks}
   j:=pos(#193,Chart[i]);
   while j<>0 do begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
      j:=pos(#193,Chart[i]);
   end;
{vertical lines}
   st:=#124;
   j:=pos(#179,Chart[i]);
   while j<>0 do begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
      j:=pos(#179,Chart[i]);
   end;
{timespan marks}
   st:=#35;
   j:=pos(#219,Chart[i]);
   while j<>0 do begin
      delete(Chart[i],j,1);
      insert(st,Chart[i],j);
      j:=pos(#219,Chart[i]);
   end;
   end; {replace extended ASCII}
end;

{Save .PRN files}
   assign(PrnFile,filename + '.PRN');
   Error_Ck(error);
   if error then goto PrtFile;

   rewrite(PrnFile);
   Error_Ck(error);
   if error then goto PrtFile;

if narrow then {turn on bold,IBM extended character set}
      write(PrnFile,#27,'E',#27,6);

{dates, top border, and first task}
   for j:=1 to 5 do begin
       writeln(PrnFile,Chart[j]);
       Error_Ck(error);
       if error then goto PrtFile;
       {close spacing for narrow chart}
       if (j=3) and (narrow) then write(PrnFile,#27,'1');
       Error_Ck(error);
       if error then goto PrtFile;
   end;

   {rest of tasks with spacing}
   for j:=6 to Taskcount+4 do begin
       for k:=1 to Spaces do begin
           writeln(PrnFile,Chart[L]);
           Error_Ck(error);
           if error then goto PrtFile;
       end;

       writeln(PrnFile,Chart[j]);
       Error_Ck(error);
       if error then goto PrtFile;
   end;

   {bottom chart line}
   writeln(PrnFile,Chart[j+1]);
   Error_Ck(error);
   if error then goto PrtFile;

   {add blank rows to center heading vertically}
   i:=(L- TaskCount - 13 - (TaskCount-1) * Spaces) div 2;
   if i<1 then i:=1;
   for j:=1 to i do writeln(PrnFile);
   Error_Ck(error);
   if error then goto PrtFile;

   for j:=1 to 2 do begin
       Writeln(PrnFile,TitleLine[j]);
       Error_Ck(error);
       if error then goto PrtFile;

       writeln(PrnFile);
       Error_Ck(error);
       if error then goto PrtFile;
   end; {for}

if narrow then write(PrnFile,#27,'2');

   for j:=3 to 6 do begin
       writeln(PrnFile,TitleLine[j]);
       Error_Ck(error);
       if error then goto PrtFile;
   end;

PrtFile:
   close(PrnFile);
   Error_Ck(error);
   if error then begin
      erase(PrnFile);
      error:=(IOResult<>0);
      erase(DtaFile);
      error:=(IOResult<>0);
   end;
{$I+}
end;{Save}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Input_Filename2 (st:str12;  {'print' or 'load'}
                       var filename:str12);
{purpose: allow user to select the default filename with mouse
          or <cr>
 external I/O: none
 global data: none
 called by: Load
            Print_Chart
 modules used: GetFile
               Hide_Cursor
               Show_Cursor
               ESC         }

const x = 45;
      y = 5;
var temp: str12;

begin {Input_Filename2}

  Hide_Cursor;
  window(1,1,80,25);
  TextColor(C1);
  TextBackground(B1);
  ClrScr;

   gotoxy(25,y); write('filename to ',st,':');
   TextColor(C2);TextBackground(B2);
   gotoxy(1,24); write(' <Esc> to Abort');
   gotoxy(2,25);
   insline;
   write('<cr> for this chart');
   gotoxy(38,25); write('<space> for disk directory or path change');

   gotoxy(x,y);
   write(filename);
   temp:=filename;
   filename:='';

repeat
   if keypressed then begin
      read(kbd,ch);
      case ch of
          #27: if not keypressed then begin {<Esc> pressed}
                ESC;
                if abandon then exit;
                gotoxy(x,y);
             end; {<Esc> pressed}

          #13: {<cr>}
               if (temp<>'') then begin
                  {strip any spaces from filename}
                  repeat
                       delete(temp,pos(' ',temp),1);
                  until pos(' ',temp)=0;
                  filename:=temp;
               end; {if temp<>''}
          #32: {space} begin
               filename:=GetFile;
               if filename='' then begin

           {restore screen}
                  TextColor(C1);
                  TextBackground(B1);
                  ClrScr;
                  gotoxy(25,y); write('filename to ',st,':');
                  TextColor(C2);TextBackground(B2);
                  gotoxy(2,25);
                  insline;
                  write('<Esc> to abandon chart');
                  gotoxy(38,25);
                  write('<space> for disk directory or path change');
                  gotoxy(x,y);write(temp);

               end; {filename=''}

             end; {space}

     end; {case}
   end; {if keypressed}

{select default filename with mouse}
   if mice then begin
      M1:=5; {get button status}
      M2:=0; {left button}
      Mouse(M1,M2,M3,M4);
      if M2>0 then filename:=temp;
   end; {if mice}

   until filename<>'';
   Show_Cursor;
end; {Input_Filename2}

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Load(var filename:Str12);

{purpose: to load an old chart for update
 date: 4/19/87
 external I/O: input from filename.DTA
 Global Data: Task
 Called by: Main
 Modules used: Input_Filemane }

label InputFile;

var i,j:integer; {loop control}
    DtaFile:file of TaskType;
    Error:boolean;

begin {Load_File}

  Textmode(C80);Textbackground(B2); {select wide or narrow chart}
  ClrScr; TextColor(C2);
  gotoxy(30,10); write('1. Wide chart');
  gotoxy(30,12);
        write('2. Narrow chart');
        gotoxy(19,23);
        write('IMPORTANT: DATA disk CANNOT have a write protect tab!');
        Hide_Cursor;
        gotoxy(30,17); write('Enter your selection:');
        textcolor(B2);textbackground(C2);write(' ');
  repeat read(kbd,ch) until ((ch='1') or (ch='2'));
  if ch='1' then begin
     w:=114;
     narrow:=false
  end
  else begin
       w:=79;
       narrow:=True
  end;

    Hide_Cursor;
    error:=false;
InputFile:

if filename<>'' then Input_Filename2('load',filename)
else
 repeat
     filename:=getfile;
     if filename='' then ESC;
     if abandon then exit;
 until filename<>'';

{$I-}
   assign(DtaFile,filename+'.DTA');
   Error_Ck(error);
   if Error then goto InputFile;

   reset(DtaFile);
   Error_Ck(error);
   if Error then goto InputFile;

   read(DtaFile,Task);
   Error_Ck(error);
   if Error then goto InputFile;

   close(DtaFile);
   Error_Ck(error);
   if Error then goto InputFile;

{$I+}
   Show_Cursor;
end; {Load_File}

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
procedure Print_Chart(var filename:Str12);
{purpose: print a gantt chart
 external I/O: spawns the program Sideways.Com
 global data: none
 called by: Main
 modules used: Input_File
               Error_Ck
               Spawn
               GetFile
               ESC    }

var error:boolean;
    message: string[40];

begin {Print_Chart}

  Hide_Cursor;
  Error:=false;
  message:='';

if filename<>'' then Input_Filename2('print',filename)
else
  repeat
      filename:=getfile;
      if filename='' then ESC;
      if abandon then exit;
  until filename<>'';


  if narrow then
     message:='Type '+ filename + '.PRN > prn'
  else if W<110 then message:='A:SWC ' + filename +'.PRN'
       else message:='A:Sideways/O=A:Gantt '+filename+'.PRN';

  spawn(message);
  delay(1500);

  Show_Cursor;
end; {Print_Chart}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
Procedure Housekeep;
begin {Housekeep}
  TextMode(c80);
  ClrScr;
  if Mice then begin {reset mouse}
    M1:=0;
    Mouse(M1,M2,M3,M4);
  end; {if mouse}
end;  {Housekeep}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
{end of Gantt.inc}

